umbrello: IDLImport Class Reference

umbrello 2.38.2 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
IDLImport Class Reference

`#include <idlimport.h>`

Inheritance diagram for IDLImport:

## Public Member Functions
| IDLImport (CodeImpThread *thread=0)
virtual | ~IDLImport ()
bool | parseStmt ()
bool | parseFile (const QString &file)
bool | preprocess (QString &line)
void | fillSource (const QString &word)
bool | skipStructure ()
bool | isValidScopedName (QString text)
Public Member Functions inherited from NativeImportBase
| NativeImportBase (const QString &singleLineCommentIntro, CodeImpThread *thread=0)
virtual | ~NativeImportBase ()
Public Member Functions inherited from ClassImport
| ClassImport (CodeImpThread *thread=0)
virtual | ~ClassImport ()
bool | importFiles (const QStringList &fileNames)
bool | importFile (const QString &fileName)
void | setRootPath (const QString &path)
bool | enabled () const

## Protected Member Functions
QString | joinTypename ()
| Check for split type names (e.g. unsigned long long)
Protected Member Functions inherited from NativeImportBase
void | initialize ()
void | setMultiLineComment (const QString &intro, const QString &end)
void | setMultiLineAltComment (const QString &intro, const QString &end)
virtual bool | parseFile (const QString &filename)
virtual void | initVars ()
void | scan (const QString &line)
virtual bool | preprocess (QString &line)
virtual QStringList | split (const QString &line)
virtual void | fillSource (const QString &word)=0
virtual bool | parseStmt ()=0
void | skipStmt (const QString &until=QStringLiteral(";"))
bool | skipToClosing (QChar opener)
QString | current ()
QString | lookAhead ()
virtual QString | advance ()
void | pushScope (UMLPackage *p)
UMLPackage * | popScope ()
UMLPackage * | currentScope ()
int | scopeIndex ()
Protected Member Functions inherited from ClassImport
virtual void | initialize ()=0
virtual void | initPerFile ()
virtual bool | parseFile (const QString &fileName)=0
void | log (const QString &file, const QString &text)
void | log (const QString &text)

## Protected Attributes
UMLDoc * | m_doc
bool | m_isOneway
bool | m_isReadonly
bool | m_isAttribute
bool | m_isUnionDefault
QStringList | m_unionCases
Protected Attributes inherited from NativeImportBase
QString | m_singleLineCommentIntro
| start token of a single line comment
QStringList | m_source
| the scanned lexemes
int | m_srcIndex
| used for indexing m_source
QList< UMLPackage * > | m_scope
| stack of scopes for use by the specific importer
UMLClassifier * | m_klass
| class currently being processed
Uml::Visibility::Enum | m_currentAccess
| current access (public/protected/private)
QString | m_comment
| intermediate accumulator for comment text
bool | m_inComment
bool | m_isAbstract
| accumulator for abstractness
QString | m_multiLineCommentIntro
| multi line comment delimiter intro
QString | m_multiLineCommentEnd
| multi line comment delimiter end
QString | m_multiLineAltCommentIntro
QString | m_multiLineAltCommentEnd
Protected Attributes inherited from ClassImport
CodeImpThread * | m_thread
| thread in which the work of importing is done
bool | m_enabled
| state of importer
QString | m_rootPath
| root path of import

## Static Protected Attributes
static QString | m_preProcessor
static QStringList | m_preProcessorArguments
static bool | m_preProcessorChecked = false
Static Protected Attributes inherited from NativeImportBase
static QStringList | m_parsedFiles

## Additional Inherited Members
Static Public Member Functions inherited from ClassImport
static ClassImport * | createImporterByFileExt (const QString &fileName, CodeImpThread *thread=0)

## Detailed Description

CORBA IDL code import

Author
  Oliver Kellogg Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ IDLImport()

IDLImport::IDLImport | ( | CodeImpThread * | thread = `0` | ) |
| explicit

## ◆ ~IDLImport()

IDLImport::~IDLImport | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ fillSource()

void IDLImport::fillSource | ( | const QString & | word | ) |
| virtual

Implement abstract operation from NativeImportBase.

Implements NativeImportBase.

## ◆ isValidScopedName()

bool IDLImport::isValidScopedName | ( | QString | text | ) |

Returns true if the given text is a valid IDL scoped name.

## ◆ joinTypename()

QString IDLImport::joinTypename | ( |  | ) |
| protected

Check for split type names (e.g. unsigned long long)

## ◆ parseFile()

bool IDLImport::parseFile | ( | const QString & | filename | ) |
| virtual

Reimplement operation from NativeImportBase. Need to do this because we use the external C preprocessor.

Reimplemented from NativeImportBase.

## ◆ parseStmt()

bool IDLImport::parseStmt | ( |  | ) |
| virtual

Implement abstract operation from NativeImportBase. The function only returns false if an error is encountered from which no recovery is possible. On recoverable syntax errors, the function issues an error message, skips to the end of the offending declaration, and returns true. Returning true in spite of a local syntax error is done in the interest of best effort (returning false would abort the entire code import). A syntax error is typically unrecoverable when it involves imbalance of braces, in particular when the closing "}" of an opening "{" is missing.

Implements NativeImportBase.

## ◆ preprocess()

bool IDLImport::preprocess | ( | QString & | line | ) |
| virtual

Override operation from NativeImportBase.

Reimplemented from NativeImportBase.

## ◆ skipStructure()

bool IDLImport::skipStructure | ( |  | ) |

Skip to the end of struct/union/valuetype/interface declaration.

Returns
  True for success, false for non recoverable syntax error related to brace matching (missing opening or closing brace).

## Member Data Documentation

## ◆ m_doc

UMLDoc* IDLImport::m_doc
| protected

## ◆ m_isAttribute

bool IDLImport::m_isAttribute
| protected

## ◆ m_isOneway

bool IDLImport::m_isOneway
| protected

## ◆ m_isReadonly

bool IDLImport::m_isReadonly
| protected

## ◆ m_isUnionDefault

bool IDLImport::m_isUnionDefault
| protected

## ◆ m_preProcessor

QString IDLImport::m_preProcessor
| staticprotected

## ◆ m_preProcessorArguments

QStringList IDLImport::m_preProcessorArguments
| staticprotected

## ◆ m_preProcessorChecked

bool IDLImport::m_preProcessorChecked = false
| staticprotected

## ◆ m_unionCases

QStringList IDLImport::m_unionCases
| protected

The documentation for this class was generated from the following files:

- umbrello/codeimport/idlimport.h
- umbrello/codeimport/idlimport.cpp